class Project < ApplicationRecord
  belongs_to :owner, class_name: 'User', foreign_key: :user_id

  has_many :members
  has_many :manager_members, -> { joins(:roles).where(roles: { name: 'Manager' }) }, class_name: 'Member'
  has_one :project_score, dependent: :destroy

  has_many :issues
  has_many :user_grades, dependent: :destroy
  has_many :attachments, as: :container, dependent: :destroy
  has_one :project_score, dependent: :destroy
  has_many :versions, -> { order("versions.effective_date DESC, versions.name DESC") }, dependent: :destroy


  # 创建者
  def creator
    User.find(user_id).full_name
  end

  def project_members
    self.members
  end

  def member?(user)
    members.exists?(user_id: user.id)
  end

end
